

<!DOCTYPE html>



<head>
    <meta charset="utf-8" />
    <meta name="author" content="Apple Inc." />
    <meta name="viewport" content="width=device-width initial-scale=1" />
    
    <title>Subscripts &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css" />
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico" />
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png" />
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png" />
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png" />
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png" />
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png" />
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png" />
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png" />
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png" />
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png" />
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339" /> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="TheBasics.html">Language Guide</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="TheBasics.html">The Basics</a></li>
<li class="toctree-l2"><a class="reference internal" href="BasicOperators.html">Basic Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="StringsAndCharacters.html">Strings and Characters</a></li>
<li class="toctree-l2"><a class="reference internal" href="CollectionTypes.html">Collection Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="ControlFlow.html">Control Flow</a></li>
<li class="toctree-l2"><a class="reference internal" href="Functions.html">Functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Closures.html">Closures</a></li>
<li class="toctree-l2"><a class="reference internal" href="Enumerations.html">Enumerations</a></li>
<li class="toctree-l2"><a class="reference internal" href="ClassesAndStructures.html">Structures and Classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Properties.html">Properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="Methods.html">Methods</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="Subscripts.html#">Subscripts</a></li>
<li class="toctree-l2"><a class="reference internal" href="Inheritance.html">Inheritance</a></li>
<li class="toctree-l2"><a class="reference internal" href="Initialization.html">Initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="Deinitialization.html">Deinitialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="OptionalChaining.html">Optional Chaining</a></li>
<li class="toctree-l2"><a class="reference internal" href="ErrorHandling.html">Error Handling</a></li>
<li class="toctree-l2"><a class="reference internal" href="TypeCasting.html">Type Casting</a></li>
<li class="toctree-l2"><a class="reference internal" href="NestedTypes.html">Nested Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="Extensions.html">Extensions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Protocols.html">Protocols</a></li>
<li class="toctree-l2"><a class="reference internal" href="Generics.html">Generics</a></li>
<li class="toctree-l2"><a class="reference internal" href="AutomaticReferenceCounting.html">Automatic Reference Counting</a></li>
<li class="toctree-l2"><a class="reference internal" href="MemorySafety.html">Memory Safety</a></li>
<li class="toctree-l2"><a class="reference internal" href="AccessControl.html">Access Control</a></li>
<li class="toctree-l2"><a class="reference internal" href="AdvancedOperators.html">Advanced Operators</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">← Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="Subscripts.html#">Subscripts</a><ul>
<li><a class="reference internal" href="Subscripts.html#ID306">Subscript Syntax</a></li>
<li><a class="reference internal" href="Subscripts.html#ID307">Subscript Usage</a></li>
<li><a class="reference internal" href="Subscripts.html#ID308">Subscript Options</a></li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="subscripts">
<h1>Subscripts<a class="headerlink" href="Subscripts.html#subscripts" title="Permalink to this headline"></a></h1>
<p>Classes, structures, and enumerations can define <em>subscripts</em>, which are shortcuts for accessing the member elements of a collection, list, or sequence. You use subscripts to set and retrieve values by index without needing separate methods for setting and retrieval. For example, you access elements in an <code class="docutils literal"><span class="pre">Array</span></code> instance as <code class="docutils literal"><span class="pre">someArray[index]</span></code> and elements in a <code class="docutils literal"><span class="pre">Dictionary</span></code> instance as <code class="docutils literal"><span class="pre">someDictionary[key]</span></code>.</p>
<p>You can define multiple subscripts for a single type, and the appropriate subscript overload to use is selected based on the type of index value you pass to the subscript. Subscripts are not limited to a single dimension, and you can define subscripts with multiple input parameters to suit your custom type’s needs.</p>
<div class="section" id="ID306">
<h2>Subscript Syntax<a class="headerlink" href="Subscripts.html#ID306" title="Permalink to this headline"></a></h2>
<p>Subscripts enable you to query instances of a type by writing one or more values in square brackets after the instance name. Their syntax is similar to both instance method syntax and computed property syntax. You write subscript definitions with the <code class="docutils literal"><span class="pre">subscript</span></code> keyword, and specify one or more input parameters and a return type, in the same way as instance methods. Unlike instance methods, subscripts can be read-write or read-only. This behavior is communicated by a getter and setter in the same way as for computed properties:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">subscript</span>(<span class="nv">index</span>: <span class="nc">Int</span>) -&gt; <span class="nc">Int</span> {
</li><li>    <span class="k">get</span> {
</li><li>        <span class="c">// return an appropriate subscript value here</span>
</li><li>    }
</li><li>    <span class="k">set</span>(<span class="nv">newValue</span>) {
</li><li>        <span class="c">// perform a suitable setting action here</span>
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>The type of <code class="docutils literal"><span class="pre">newValue</span></code> is the same as the return value of the subscript. As with computed properties, you can choose not to specify the setter’s <code class="docutils literal"><span class="pre">(newValue)</span></code> parameter. A default parameter called <code class="docutils literal"><span class="pre">newValue</span></code> is provided to your setter if you do not provide one yourself.</p>
<p>As with read-only computed properties, you can simplify the declaration of a read-only subscript by removing the <code class="docutils literal"><span class="pre">get</span></code> keyword and its braces:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">subscript</span>(<span class="nv">index</span>: <span class="nc">Int</span>) -&gt; <span class="nc">Int</span> {
</li><li>    <span class="c">// return an appropriate subscript value here</span>
</li><li>}
</li></ol></pre></div></div>
<p>Here’s an example of a read-only subscript implementation, which defines a <code class="docutils literal"><span class="pre">TimesTable</span></code> structure to represent an <em>n</em>-times-table of integers:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">struct</span> <span class="nv">TimesTable</span> {
</li><li>    <span class="k">let</span> <span class="nv">multiplier</span>: <span class="nc">Int</span>
</li><li>    <span class="k">subscript</span>(<span class="nv">index</span>: <span class="nc">Int</span>) -&gt; <span class="nc">Int</span> {
</li><li>        <span class="k">return</span> <span class="nv">multiplier</span> * <span class="nv">index</span>
</li><li>    }
</li><li>}
</li><li><span class="k">let</span> <span class="nv">threeTimesTable</span> = <span class="nv">TimesTable</span>(<span class="nv">multiplier</span>: <span class="m">3</span>)
</li><li><span class="nv">print</span>(<span class="s">&quot;six times three is </span>\<span class="p">(</span><span class="nv">threeTimesTable</span>[<span class="m">6</span>]<span class="p">)</span><span class="s">&quot;</span>)
</li><li><span class="c">// Prints &quot;six times three is 18&quot;</span>
</li></ol></pre></div></div>
<p>In this example, a new instance of <code class="docutils literal"><span class="pre">TimesTable</span></code> is created to represent the three-times-table. This is indicated by passing a value of <code class="docutils literal"><span class="pre">3</span></code> to the structure’s <code class="docutils literal"><span class="pre">initializer</span></code> as the value to use for the instance’s <code class="docutils literal"><span class="pre">multiplier</span></code> parameter.</p>
<p>You can query the <code class="docutils literal"><span class="pre">threeTimesTable</span></code> instance by calling its subscript, as shown in the call to <code class="docutils literal"><span class="pre">threeTimesTable[6]</span></code>. This requests the sixth entry in the three-times-table, which returns a value of <code class="docutils literal"><span class="pre">18</span></code>, or <code class="docutils literal"><span class="pre">3</span></code> times <code class="docutils literal"><span class="pre">6</span></code>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">An <em>n</em>-times-table is based on a fixed mathematical rule. It is not appropriate to set <code class="docutils literal"><span class="pre">threeTimesTable[someIndex]</span></code> to a new value, and so the subscript for <code class="docutils literal"><span class="pre">TimesTable</span></code> is defined as a read-only subscript.</p>
</div>
</div>
<div class="section" id="ID307">
<h2>Subscript Usage<a class="headerlink" href="Subscripts.html#ID307" title="Permalink to this headline"></a></h2>
<p>The exact meaning of “subscript” depends on the context in which it is used. Subscripts are typically used as a shortcut for accessing the member elements in a collection, list, or sequence. You are free to implement subscripts in the most appropriate way for your particular class or structure’s functionality.</p>
<p>For example, Swift’s <code class="docutils literal"><span class="pre">Dictionary</span></code> type implements a subscript to set and retrieve the values stored in a <code class="docutils literal"><span class="pre">Dictionary</span></code> instance. You can set a value in a dictionary by providing a key of the dictionary’s key type within subscript brackets, and assigning a value of the dictionary’s value type to the subscript:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">numberOfLegs</span> = [<span class="s">&quot;spider&quot;</span>: <span class="m">8</span>, <span class="s">&quot;ant&quot;</span>: <span class="m">6</span>, <span class="s">&quot;cat&quot;</span>: <span class="m">4</span>]
</li><li><span class="nv">numberOfLegs</span>[<span class="s">&quot;bird&quot;</span>] = <span class="m">2</span>
</li></ol></pre></div></div>
<p>The example above defines a variable called <code class="docutils literal"><span class="pre">numberOfLegs</span></code> and initializes it with a dictionary literal containing three key-value pairs. The type of the <code class="docutils literal"><span class="pre">numberOfLegs</span></code> dictionary is inferred to be <code class="docutils literal"><span class="pre">[String:</span> <span class="pre">Int]</span></code>. After creating the dictionary, this example uses subscript assignment to add a <code class="docutils literal"><span class="pre">String</span></code> key of <code class="docutils literal"><span class="pre">&quot;bird&quot;</span></code> and an <code class="docutils literal"><span class="pre">Int</span></code> value of <code class="docutils literal"><span class="pre">2</span></code> to the dictionary.</p>
<p>For more information about <code class="docutils literal"><span class="pre">Dictionary</span></code> subscripting, see <a class="reference internal" href="CollectionTypes.html#ID116"><span class="std std-ref">Accessing and Modifying a Dictionary</span></a>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Swift’s <code class="docutils literal"><span class="pre">Dictionary</span></code> type implements its key-value subscripting as a subscript that takes and returns an <em>optional</em> type. For the <code class="docutils literal"><span class="pre">numberOfLegs</span></code> dictionary above, the key-value subscript takes and returns a value of type <code class="docutils literal"><span class="pre">Int?</span></code>, or “optional int”. The <code class="docutils literal"><span class="pre">Dictionary</span></code> type uses an optional subscript type to model the fact that not every key will have a value, and to give a way to delete a value for a key by assigning a <code class="docutils literal"><span class="pre">nil</span></code> value for that key.</p>
</div>
</div>
<div class="section" id="ID308">
<h2>Subscript Options<a class="headerlink" href="Subscripts.html#ID308" title="Permalink to this headline"></a></h2>
<p>Subscripts can take any number of input parameters, and these input parameters can be of any type. Subscripts can also return any type. Subscripts can use variadic parameters, but they can’t use in-out parameters or provide default parameter values.</p>
<p>A class or structure can provide as many subscript implementations as it needs, and the appropriate subscript to be used will be inferred based on the types of the value or values that are contained within the subscript brackets at the point that the subscript is used. This definition of multiple subscripts is known as <em>subscript overloading</em>.</p>
<p>While it is most common for a subscript to take a single parameter, you can also define a subscript with multiple parameters if it is appropriate for your type. The following example defines a <code class="docutils literal"><span class="pre">Matrix</span></code> structure, which represents a two-dimensional matrix of <code class="docutils literal"><span class="pre">Double</span></code> values. The <code class="docutils literal"><span class="pre">Matrix</span></code> structure’s subscript takes two integer parameters:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">struct</span> <span class="nv">Matrix</span> {
</li><li>    <span class="k">let</span> <span class="nv">rows</span>: <span class="nc">Int</span>, <span class="nv">columns</span>: <span class="nc">Int</span>
</li><li>    <span class="k">var</span> <span class="nv">grid</span>: [<span class="nc">Double</span>]
</li><li>    <span class="k">init</span>(<span class="nv">rows</span>: <span class="nc">Int</span>, <span class="nv">columns</span>: <span class="nc">Int</span>) {
</li><li>        <span class="k">self</span>.<span class="nv">rows</span> = <span class="nv">rows</span>
</li><li>        <span class="k">self</span>.<span class="nv">columns</span> = <span class="nv">columns</span>
</li><li>        <span class="nv">grid</span> = <span class="nv">Array</span>(<span class="nv">repeating</span>: <span class="m">0.0</span>, <span class="nv">count</span>: <span class="nv">rows</span> * <span class="nv">columns</span>)
</li><li>    }
</li><li>    <span class="k">func</span> <span class="nv">indexIsValid</span>(<span class="nv">row</span>: <span class="nc">Int</span>, <span class="nv">column</span>: <span class="nc">Int</span>) -&gt; <span class="nc">Bool</span> {
</li><li>        <span class="k">return</span> <span class="nv">row</span> &gt;= <span class="m">0</span> &amp;&amp; <span class="nv">row</span> &lt; <span class="nv">rows</span> &amp;&amp; <span class="nv">column</span> &gt;= <span class="m">0</span> &amp;&amp; <span class="nv">column</span> &lt; <span class="nv">columns</span>
</li><li>    }
</li><li>    <span class="k">subscript</span>(<span class="nv">row</span>: <span class="nc">Int</span>, <span class="nv">column</span>: <span class="nc">Int</span>) -&gt; <span class="nc">Double</span> {
</li><li>        <span class="k">get</span> {
</li><li>            <span class="nv">assert</span>(<span class="nv">indexIsValid</span>(<span class="nv">row</span>: <span class="nv">row</span>, <span class="nv">column</span>: <span class="nv">column</span>), <span class="s">&quot;Index out of range&quot;</span>)
</li><li>            <span class="k">return</span> <span class="nv">grid</span>[(<span class="nv">row</span> * <span class="nv">columns</span>) + <span class="nv">column</span>]
</li><li>        }
</li><li>        <span class="k">set</span> {
</li><li>            <span class="nv">assert</span>(<span class="nv">indexIsValid</span>(<span class="nv">row</span>: <span class="nv">row</span>, <span class="nv">column</span>: <span class="nv">column</span>), <span class="s">&quot;Index out of range&quot;</span>)
</li><li>            <span class="nv">grid</span>[(<span class="nv">row</span> * <span class="nv">columns</span>) + <span class="nv">column</span>] = <span class="nv">newValue</span>
</li><li>        }
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p><code class="docutils literal"><span class="pre">Matrix</span></code> provides an initializer that takes two parameters called <code class="docutils literal"><span class="pre">rows</span></code> and <code class="docutils literal"><span class="pre">columns</span></code>, and creates an array that is large enough to store <code class="docutils literal"><span class="pre">rows</span> <span class="pre">*</span> <span class="pre">columns</span></code> values of type <code class="docutils literal"><span class="pre">Double</span></code>. Each position in the matrix is given an initial value of <code class="docutils literal"><span class="pre">0.0</span></code>. To achieve this, the array’s size, and an initial cell value of <code class="docutils literal"><span class="pre">0.0</span></code>, are passed to an array initializer that creates and initializes a new array of the correct size. This initializer is described in more detail in <a class="reference internal" href="CollectionTypes.html#ID501"><span class="std std-ref">Creating an Array with a Default Value</span></a>.</p>
<p>You can construct a new <code class="docutils literal"><span class="pre">Matrix</span></code> instance by passing an appropriate row and column count to its initializer:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">matrix</span> = <span class="nv">Matrix</span>(<span class="nv">rows</span>: <span class="m">2</span>, <span class="nv">columns</span>: <span class="m">2</span>)
</li></ol></pre></div></div>
<p>The example above creates a new <code class="docutils literal"><span class="pre">Matrix</span></code> instance with two rows and two columns. The <code class="docutils literal"><span class="pre">grid</span></code> array for this <code class="docutils literal"><span class="pre">Matrix</span></code> instance is effectively a flattened version of the matrix, as read from top left to bottom right:</p>
<img alt="../_images/subscriptMatrix01_2x.png" class="align-center" src="../_images/subscriptMatrix01_2x.png" style="width: 280px;" />
<p>Values in the matrix can be set by passing row and column values into the subscript, separated by a comma:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">matrix</span>[<span class="m">0</span>, <span class="m">1</span>] = <span class="m">1.5</span>
</li><li><span class="nv">matrix</span>[<span class="m">1</span>, <span class="m">0</span>] = <span class="m">3.2</span>
</li></ol></pre></div></div>
<p>These two statements call the subscript’s setter to set a value of <code class="docutils literal"><span class="pre">1.5</span></code> in the top right position of the matrix (where <code class="docutils literal"><span class="pre">row</span></code> is <code class="docutils literal"><span class="pre">0</span></code> and <code class="docutils literal"><span class="pre">column</span></code> is <code class="docutils literal"><span class="pre">1</span></code>), and <code class="docutils literal"><span class="pre">3.2</span></code> in the bottom left position (where <code class="docutils literal"><span class="pre">row</span></code> is <code class="docutils literal"><span class="pre">1</span></code> and <code class="docutils literal"><span class="pre">column</span></code> is <code class="docutils literal"><span class="pre">0</span></code>):</p>
<img alt="../_images/subscriptMatrix02_2x.png" class="align-center" src="../_images/subscriptMatrix02_2x.png" style="width: 98px;" />
<p>The <code class="docutils literal"><span class="pre">Matrix</span></code> subscript’s getter and setter both contain an assertion to check that the subscript’s <code class="docutils literal"><span class="pre">row</span></code> and <code class="docutils literal"><span class="pre">column</span></code> values are valid. To assist with these assertions, <code class="docutils literal"><span class="pre">Matrix</span></code> includes a convenience method called <code class="docutils literal"><span class="pre">indexIsValid(row:column:)</span></code>, which checks whether the requested <code class="docutils literal"><span class="pre">row</span></code> and <code class="docutils literal"><span class="pre">column</span></code> are inside the bounds of the matrix:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">indexIsValid</span>(<span class="nv">row</span>: <span class="nc">Int</span>, <span class="nv">column</span>: <span class="nc">Int</span>) -&gt; <span class="nc">Bool</span> {
</li><li>    <span class="k">return</span> <span class="nv">row</span> &gt;= <span class="m">0</span> &amp;&amp; <span class="nv">row</span> &lt; <span class="nv">rows</span> &amp;&amp; <span class="nv">column</span> &gt;= <span class="m">0</span> &amp;&amp; <span class="nv">column</span> &lt; <span class="nv">columns</span>
</li><li>}
</li></ol></pre></div></div>
<p>An assertion is triggered if you try to access a subscript that is outside of the matrix bounds:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">someValue</span> = <span class="nv">matrix</span>[<span class="m">2</span>, <span class="m">2</span>]
</li><li><span class="c">// this triggers an assert, because [2, 2] is outside of the matrix bounds</span>
</li></ol></pre></div></div>
</div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="Methods.html">Methods</a></p>
        <p class="next"><a href="Inheritance.html">Inheritance</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple's beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  </body>
</html>
